import { csvParse, select } from 'd3';

export const viz = (
  container,
  { state, setState }
) => {
  
  select(container)
    .selectAll('pre')
    .data([null])
    .join('pre')
    .text(JSON.stringify(state.data, null, 2));
 
  // state.data could be:
  // * undefined
  // * 'LOADING'
  // * An array of objects
  const { data } = state;

  if (data === undefined) {
    setState((state) => ({
      ...state,
      data: 'LOADING',
    }));
    fetch('data.csv')
      .then((response) => response.text())
      .then((csvString) => {
        const data = csvParse(csvString);
      
        for (const d of data) {
          d.Day = +d.Day;
          d.Month = +d.Month;
          d.Year = +d.Year;
          d.DayPlusMinus = +d.DayPlusMinus;
          d.MonthPlusMinus = +d.MonthPlusMinus;
          d.NumCheetahs = +d.NumCheetahs;
          d.Confiscated = +d.Confiscated;
        	d.Surrendered = +d.Surrendered;
          d.Alive = +d.Alive;
          d.Died = +d.Died;
          d.LTF = +d.LTF;
          d.LTFUNKFate = +d.LTFUNKFate;
        }
      
        setState((state) => ({
          ...state,
          data,
        }));
      });
  }
};
